using System;
using System.Collections.Generic;
using System.Xml.Serialization;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmAny 
	{

		public string Name
		{
			get { return name; }
		}

		public string Access
		{
			get { return access; }
		}

		public bool OptimisticLock
		{
			get { return optimisticlock; }
		}

		public bool IsLazyProperty
		{
			get { return lazy; }
		}

	

		

		protected HbmMeta[] Metadatas
		{
			get { return meta ?? new HbmMeta[0]; }
		}

		

		[XmlIgnore]
		public IEnumerable<HbmColumn> Columns
		{
			get { return column ?? AsColumns(); }
		}

		
		private IEnumerable<HbmColumn> AsColumns()
		{
			if (string.IsNullOrEmpty(column1))
			{
				yield break;
			}
			else
			{
				yield return new HbmColumn
				{
					name = column1,
					index = index
				};
			}
		}


		public string MetaType
		{
			get { return metatype; }
		}

		public ICollection<HbmMetaValue> MetaValues
		{
			get
			{
				return metavalue ?? new HbmMetaValue[0];
			}
		}

		
	}
}