﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
    
    public partial class HbmCompositeId
    {
        List<object> itemsList = new List<object>();
        // mapped composite identifier
        public HbmCompositeId(Type idCalssType, List<PropertyHelper> idList)
            : this()
        {
            this.mapped = true;
            this.@class = MappingUtils.getStringClassDef(idCalssType);
            foreach (PropertyHelper prop in idList)
            {
                itemsList.Add(new HbmKeyProperty(prop));
            }
            this.Items = itemsList.ToArray();
        }

       
        // Embedded id ( identifier component )
        public HbmCompositeId(PropertyHelper propInfo)
        {
            Type typ = propInfo.PropertyType;
            foreach (PropertyHelper propertyInfo in MappingUtils.getProperties(typ, propInfo))
            {
                itemsList.Add(new HbmKeyProperty(propertyInfo));
            }
            
            this.Items = itemsList.ToArray();
        }

    }
}
