﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
    partial class HbmReturn
    {
        public HbmReturn(Type resultClass)
            : this()
        {
            this.@class = MappingUtils.getStringClassDef(resultClass);
        }

        public HbmReturn(EntityResult entity, IEnumerable<FieldResult> fieldResults)
            : this()
        {
            this.@class = MappingUtils.getStringClassDef(entity.EntityClass);
            List<HbmReturnProperty> retPropList = new List<HbmReturnProperty>();
            foreach (FieldResult field in fieldResults)
            {
                retPropList.Add(new HbmReturnProperty(field));
            }
            this.returnproperty = retPropList.ToArray();
        }
    }
}
